unit Central_unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TCentral = class(TForm)
    MainMenu1: TMainMenu;
    Data: TMenuItem;
    Ulozit: TMenuItem;
    Nacist: TMenuItem;
    Konec: TMenuItem;
    UciteleTlac: TButton;
    TridyaZaci: TButton;
    VytvorRozvrh: TButton;
    OtevriRozvrh: TOpenDialog;
    PriorityButton: TButton;
    Predmety: TButton;
    Ucebny: TButton;
    ZobrazRozvrh: TButton;
    Rozvrh: TMenuItem;
    ZobrazitUlozeny: TMenuItem;
    Napoveda: TMenuItem;
    NapovedaProRozvrhy: TMenuItem;
    OAplikaci: TMenuItem;
    procedure KonecClick(Sender: TObject);
    procedure UciteleTlacClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TridyaZaciClick(Sender: TObject);
    procedure PriorityButtonClick(Sender: TObject);
    procedure PredmetyClick(Sender: TObject);
    procedure UcebnyClick(Sender: TObject);
    procedure VytvorRozvrhClick(Sender: TObject);
    procedure ZobrazRozvrhClick(Sender: TObject);
    procedure ZobrazitUlozenyClick(Sender: TObject);
    procedure UlozitClick(Sender: TObject);
    procedure NacistClick(Sender: TObject);
    procedure OAplikaciClick(Sender: TObject);
    procedure NapovedaProRozvrhyClick(Sender: TObject);
    end;

  TDny = (Po,Ut,St,Ct,Pa);
  THodiny = (Po1, Po2, Po3, Po4, Po5, Po6, Po7, Po8, Po9, Po10,
            Ut1, Ut2, Ut3, Ut4, Ut5, Ut6, Ut7, Ut8, Ut9, Ut10,
            St1, St2, St3, St4, St5, St6, St7, St8, St9, St10,
            Ct1, Ct2, Ct3, Ct4, Ct5, Ct6, Ct7, Ct8, Ct9, Ct10,
            Pa1, Pa2, Pa3, Pa4, Pa5, Pa6, Pa7, Pa8, Pa9, Pa10);
  THodinySet = set of THodiny;

  TPUcitel = ^TUcitel;
  TUcitel = record
           Jmeno: string[30];
           Zkratka: string[10];
           Hodiny: THodinySet;
           Dalsi: TPUcitel;
           end;

  TSouborUcitelu = File of TUcitel;

  TSeznamUcitelu = class(TObject)
                 Prvni: TPUcitel;
                 constructor Create;
                 destructor Done;
                 procedure Reset;
                 procedure Pridej(Uc:TPUcitel);
                 procedure Odstran(Jm:String);
                 procedure Napln;
                 procedure Prazdno;
                 procedure NastavNaNil;
                 procedure Uloz;
                 function VypisZkratku(Jm:String): String;
                 procedure ZadejZkratku(Jmeno:String; Zkratka:String);
                 function VratPointer(Jmeno:String): TPUcitel;
                 function VypisHodiny(Jmeno:String): THodinySet;
                 function JeVSeznamu(Jmeno:String): Boolean;
                 function JeVSeznamuZkratka(var Uc:TPUcitel;Zk:String):Boolean;
                 end;

  TPPredmet = ^TPredmet;
  TPredmet = record
             Zkratka: String[5];
             Vyucuje: String[30];
             PozadovanaUcebna: String[5];
             Kolikrat:Byte;
             Dvouhodinovka:Boolean;
             CelaTrida: Boolean;
             Zaci: set of Byte;
             Dalsi: TPPredmet;
             end;

  TPTrida = ^TTrida;
  TTrida = record
           Jmeno : String[5];
           Tridni: String[30];
           KmenovaUcebna: String[5];
           PocetZaku:Byte;
           Predmety: TPPredmet;
           PocetPredmetu: Byte;
           Dalsi: TPTrida;
           end;

  TSouborTrid = File of TTrida;
  TSouborPredmetu = File of TPredmet;

  TSeznamTrid = class(TObject)
              Prvni: TPTrida;
              constructor Create;
              destructor Done;
              procedure Reset;
              procedure Pridej(Tr:TPTrida);
              procedure Odstran(Jm:String);
              procedure Napln;
              procedure Prazdno;
              procedure NastavNaNil;
              procedure Uloz;
              procedure PridejPredmet(Tr:String;Pr:TPPredmet);
              procedure PridejPredmetUk(UkTr:TPTrida;Pr:TPPredmet);
              procedure SmazPredmet(Tr:String;Pr:String);
              procedure SmazPredmetUk(UkTr:TPTrida;Pr:String);
              function  VratPointerTrida(Jm:String):TPTrida;
              function  VratPointerPredmetUk(UkTr:TPTrida;Pr:String):TPPredmet;
              function  VratPointerPredmet(Tr:String;Pr:String):TPPredmet;
              procedure ZadejVyucujicihoUk(UkTr:TPTrida;Pr:String;Uc:String);
              procedure ZadejPozadavekNaUcebnuUk(UkTr:TPTrida;Pr:String;Uc:String);
              procedure ZadejCelaTridaUk(UkTr:TPTrida;Pr:String;Cela:Boolean);
              procedure ZadejKolikrat(UkTr:TPTrida;Pr:String;Kolikrat:Byte);
              procedure ZadejDvouhodinovka(UkTr:TPTrida;Pr:String;Dvouhodinovka:Boolean);
              function  VypisUciteleUk(UkTr:TPTrida;Pr:String):String;
              function  VypisPozadavekNaUcebnuUk(UkTr:TPTrida;Pr:String):String;
              function  VypisCelaTrida(UkTr:TPTrida;Pr:String):Boolean;
              function  VypisKolikrat(UkTr:TPTrida;Pr:String):Byte;
              function  VypisDvouhodinovka(UkTr:TPTrida;Pr:String):Boolean;
              function  JeVSeznamu(Tr:String):Boolean;
              function  JeTridni(var UkTr:TPTrida;Uc:String):Boolean;
              function  JeKmenovaUcebna(var UkTr:TPTrida;Uc:String):Boolean;
              function  JePredmet(UkTr:TPTrida;Pr:String):Boolean;
              end;

  TPNazvyPredmetu = ^TNazvyPredmetu;
  TNazvyPredmetu = record
                 Nazev: String[30];
                 Zkratka: String[5];
                 Dalsi: TPNazvyPredmetu;
                 end;
  TSouborNazvuPredmetu = File of TNazvyPredmetu;
  TSeznamNazvuPredmetu = class(TObject)
                  Prvni: TPNazvyPredmetu;
                  constructor Create;
                  destructor Done;
                  procedure Reset;
                  procedure Pridej(Uk:TPNazvyPredmetu);
                  function VratPointer(Z:String):TPNazvyPredmetu;
                  procedure Odstran(Z:String);
                  function VypisNazev(Z:String):String;
                  procedure Napln;
                  Procedure Uloz;
                  function  JeVSeznamu(Z:String):Boolean;
                  end;

  TPUcebny = ^TUcebny;
  TUcebny = record
          Jmeno:String[5];
          Popis:String[30];
          Dalsi:TPUcebny;
          end;
  TSouborUceben = File of TUcebny;
  TSeznamUceben = class(TObject)
                Prvni: TPUcebny;
                  constructor Create;
                  destructor Done;
                  procedure Reset;
                  procedure Pridej(Uk:TPUcebny);
                  function  VratPointer(Jm:String):TPUcebny;
                  procedure Odstran(Jm:String);
                  function  VypisPopis(Jm:String):String;
                  procedure Napln;
                  procedure Uloz;
                  function  JeVSeznamu(Uc:String):Boolean;
                end;

  TSouborPriorit = File of Byte;
  TSeznamPriorit = class(TObject)
                 PocetMezerZaci:Byte;
                 PocetMezerUcitele:Byte;
                 ZacatekPrvni:Byte;
                 MaloOdHodina,MaloOd:Byte;
                 constructor Create;
                 destructor Done;
                 procedure Napln;
                 procedure Uloz;
                 procedure Kopiruj(Seznam:TSeznamPriorit);
                 function VypisPocetMezerZaci:Byte;
                 function VypisPocetMezerUcitele:Byte;
                 function VypisZacatekPrvni:Byte;
                 function VypisMaloOdHodina:Byte;
                 function VypisMaloOd:Byte;
                 procedure ZadejPocetMezerZaci(Priorita:Byte);
                 procedure ZadejPocetMezerUcitele(Priorita:Byte);
                 procedure ZadejZacatekPrvni(Priorita:Byte);
                 procedure ZadejMaloOdHodina(Hodina:Byte);
                 procedure ZadejMaloOd(Priorita:Byte);
                 end;

  TPredmetNaUlozeni = record
                      Den:TDny;
                      Hodina:Byte;
                      Zkratka: String[5];
                      Vyucuje: String[30];
                      PozadovanaUcebna: String[5];
                      Dvouhodinovka:Boolean;
                      CelaTrida: Boolean;
                      Zaci: set of Byte;
                      Trida : String[5];
                      Tridni: String[30];
                      KmenovaUcebna: String[5];
                      PocetZaku:Byte;
                      ZkratkaUcitele: String[10];
                      Hodiny: THodinySet;
                      end;
  TSouborRozvrh = File of TPredmetNaUlozeni;


      { Private declarations }

    { Public declarations }

var
  Central: TCentral;
  SeznamUcitelu: TSeznamUcitelu;
  SouborUcitelu: TSouborUcitelu;
  SeznamTrid:    TSeznamTrid;
  SouborTrid:    TSouborTrid;
  SouborPredmetu:TSouborPredmetu;
  SeznamNazvuPredmetu: TSeznamNazvuPredmetu;
  SouborNazvuPredmetu: TSouborNazvuPredmetu;
  SeznamUceben:  TSeznamUceben;
  SouborUceben:  TSouborUceben;
  SeznamPriorit: TSeznamPriorit;
  SouborPriorit: TSouborPriorit;
  SouborRozvrh:  TSouborRozvrh;
  NovyRozvrh:    Boolean;

implementation

uses Ucitele_unit, Tridy_unit, Priority_unit, Predmety_unit, Ucebny_unit, TvorbaRozvrhu_unit,
  VysledkyVyberTridy_unit, OAplikaci_unit, Napoveda_unit;


{$R *.DFM}

constructor TSeznamPriorit.Create;
begin
  PocetMezerZaci := 0;
  PocetMezerUcitele := 0;
  ZacatekPrvni := 0;
  MaloOdHodina := 0;
  MaloOd := 0;
end;

destructor TSeznamPriorit.Done;
begin

end;

procedure TSeznamPriorit.Napln;
begin
  Reset(SouborPriorit);
  Read(SouborPriorit,PocetMezerZaci);
  Read(SouborPriorit,PocetMezerUcitele);
  Read(SouborPriorit,ZacatekPrvni);
  Read(SouborPriorit,MaloOdHodina);
  Read(SouborPriorit,MaloOd);
  CloseFile(SouborPriorit);
end;

procedure TSeznamPriorit.Uloz;
begin
  Rewrite(SouborPriorit);
  Write(SouborPriorit,PocetMezerZaci);
  Write(SouborPriorit,PocetMezerUcitele);
  Write(SouborPriorit,ZacatekPrvni);
  Write(SouborPriorit,MaloOdHodina);
  Write(SouborPriorit,MaloOd);
  CloseFile(SouborPriorit);
end;

procedure TSeznamPriorit.Kopiruj(Seznam:TSeznamPriorit);
begin
  PocetMezerZaci := Seznam.PocetMezerZaci;
  PocetMezerUcitele := Seznam.PocetMezerUcitele;
  ZacatekPrvni := Seznam.ZacatekPrvni;
  MaloOdHodina := Seznam.MaloOdHodina;
  MaloOd := Seznam.MaloOd;
end;

function TSeznamPriorit.VypisPocetMezerZaci:Byte;
begin
VypisPocetMezerZaci := PocetMezerZaci;
end;

function TSeznamPriorit.VypisPocetMezerUcitele:Byte;
begin
VypisPocetMezerUcitele := PocetMezerUcitele;
end;

function TSeznamPriorit.VypisZacatekPrvni:Byte;
begin
VypisZacatekPrvni := ZacatekPrvni;
end;

function TSeznamPriorit.VypisMaloOdHodina:Byte;
begin
VypisMaloOdHodina := MaloOdHodina;
end;

function TSeznamPriorit.VypisMaloOd:Byte;
begin
VypisMaloOd := MaloOd;
end;

procedure TSeznamPriorit.ZadejPocetMezerZaci(Priorita:Byte);
begin
PocetMezerZaci := Priorita;
end;

procedure TSeznamPriorit.ZadejPocetMezerUcitele(Priorita:Byte);
begin
PocetMezerUcitele := Priorita;
end;

procedure TSeznamPriorit.ZadejZacatekPrvni(Priorita:Byte);
begin
ZacatekPrvni := Priorita;
end;

procedure TSeznamPriorit.ZadejMaloOdHodina(Hodina:Byte);
begin
MaloOdHodina := Hodina;
end;

procedure TSeznamPriorit.ZadejMaloOd(Priorita:Byte);
begin
MaloOd := Priorita;
end;

constructor TSeznamUceben.Create;
begin
Prvni := nil;
end;

destructor TSeznamUceben.Done;
begin
Reset;
end;

procedure TSeznamUceben.Reset;
var Uk1,Uk2: TPUcebny;
begin
  if Prvni <> nil then
  begin
    Uk1 := Prvni;
    Uk2 := Prvni.Dalsi;
    while Uk1 <> nil do
      begin
        dispose(Uk1);
        Uk1 := Uk2;
        If Uk2 <> nil then Uk2 := Uk2.Dalsi;
      end;
    Prvni := nil;
  end;
end;


procedure TSeznamUceben.Pridej(Uk:TPUcebny);
begin
  Uk.Dalsi := Prvni;
  Prvni := Uk;
end;

function TSeznamUceben.VratPointer(Jm:String):TPUcebny;
var Uk:TPUcebny;
begin
  Uk := Prvni;
  VratPointer := nil;
  If Uk <> nil then
  begin
  while (Uk.Dalsi <> nil) AND (Uk.Jmeno <> Jm) do Uk := Uk.Dalsi;
  If Uk.Jmeno = Jm then VratPointer := Uk;
  end;
end;

procedure TSeznamUceben.Odstran(Jm:String);
var Uk1, Uk2: TPUcebny;
begin
  Uk2 := Prvni;
  Uk1 := nil;
  If Uk2 <> nil then
    begin
      While (Uk2.Dalsi <> nil) AND (Uk2.Jmeno <> Jm) do
        begin
          Uk1 := Uk2;
          Uk2 := Uk2.Dalsi;
        end;
      If Uk2.Jmeno = Jm then begin
                               If Uk1 = nil then Prvni := Uk2.Dalsi else
                                                 Uk1.Dalsi := Uk2.Dalsi;
                               dispose(Uk2);
                             end;
    end;
end;

function TSeznamUceben.VypisPopis(Jm:String):String;
var Uk:TPUcebny;
begin
Uk := VratPointer(Jm);
VypisPopis := Uk.Popis;
end;

procedure TSeznamUceben.Napln;
var Uc:TUcebny;
    Uk:TPUcebny;
begin

  While not EOF(SouborUceben) do
    begin
      read(SouborUceben,Uc);
      new(Uk);
      Uk.Jmeno := Uc.Jmeno;
      Uk.Popis := Uc.Popis;
      Uk.Dalsi := nil;
      Pridej(Uk);
    end;
  CloseFile(SouborUceben);
end;

procedure TSeznamUceben.Uloz;
var Uk:TPUcebny;
    Uc:TUcebny;
begin
  Uk := Prvni;
  Rewrite(SouborUceben);
  While not (Uk = nil) do
    begin
      Uc.Jmeno := Uk.Jmeno;
      Uc.Popis := Uk.Popis;
      write(SouborUceben,Uc);
      Uk := Uk.Dalsi;
    end;
  CloseFile(SouborUceben);
end;

function TSeznamUceben.JeVSeznamu(Uc:String):Boolean;
begin
  If VratPointer(Uc) = nil then JeVSeznamu := False else JeVSeznamu := True;
end;






constructor TSeznamNazvuPredmetu.Create;
begin
Prvni := nil;
end;

destructor TSeznamNazvuPredmetu.Done;
begin
Reset;
end;

procedure TSeznamNazvuPredmetu.Reset;
var Uk1,Uk2: TPNazvyPredmetu;
begin
  if Prvni <> nil then
  begin
    Uk1 := Prvni;
    Uk2 := Prvni.Dalsi;
    while Uk1 <> nil do
      begin
        dispose(Uk1);
        Uk1 := Uk2;
        If Uk2 <> nil then Uk2 := Uk2.Dalsi;
      end;
    Prvni := nil;
  end;
end;


procedure TSeznamNazvuPredmetu.Pridej(Uk:TPNazvyPredmetu);
begin
  Uk.Dalsi := Prvni;
  Prvni := Uk;
end;

function TSeznamNazvuPredmetu.VratPointer(Z:String):TPNazvyPredmetu;
var Uk:TPNazvyPredmetu;
begin
  Uk := Prvni;
  VratPointer := nil;
  If Uk <> nil then
  begin
  while (Uk.Dalsi <> nil) AND (Uk.Zkratka <> Z) do Uk := Uk.Dalsi;
  If Uk.Zkratka = Z then VratPointer := Uk;
  end;
end;

procedure TSeznamNazvuPredmetu.Odstran(Z:String);
var Uk1, Uk2: TPNazvyPredmetu;
begin
  Uk2 := Prvni;
  Uk1 := nil;
  If Uk2 <> nil then
    begin
      While (Uk2.Dalsi <> nil) AND (Uk2.Zkratka <> Z) do
        begin
          Uk1 := Uk2;
          Uk2 := Uk2.Dalsi;
        end;
      If Uk2.Zkratka = Z then begin
                               If Uk1 = nil then Prvni := Uk2.Dalsi else
                                                 Uk1.Dalsi := Uk2.Dalsi;
                               dispose(Uk2);
                             end;
    end;
end;

function TSeznamNazvuPredmetu.VypisNazev(Z:String):String;
var Uk:TPNazvyPredmetu;
begin
Uk := VratPointer(Z);
If Uk <> nil then VypisNazev := Uk.Nazev else VypisNazev := '';
end;

procedure TSeznamNazvuPredmetu.Napln;
var Pr:TNazvyPredmetu;
    Uk:TPNazvyPredmetu;
begin

  While not EOF(SouborNazvuPredmetu) do
    begin
      read(SouborNazvuPredmetu,Pr);
      new(Uk);
      Uk.Nazev := Pr.Nazev;
      Uk.Zkratka := Pr.Zkratka;
      Uk.Dalsi := nil;
      Pridej(Uk);
    end;
  CloseFile(SouborNazvuPredmetu);
end;

procedure TSeznamNazvuPredmetu.Uloz;
var Uk:TPNazvyPredmetu;
    Pr:TNazvyPredmetu;
begin
  Uk := Prvni;
  Rewrite(SouborNazvuPredmetu);
  While not (Uk = nil) do
    begin
      Pr.Nazev := Uk.Nazev;
      Pr.Zkratka := Uk.Zkratka;
      Pr.Dalsi := nil;
      write(SouborNazvuPredmetu,Pr);
      Uk := Uk.Dalsi;
    end;
  CloseFile(SouborNazvuPredmetu);
end;

function TSeznamNazvuPredmetu.JeVSeznamu(Z:String):Boolean;
begin
  If VratPointer(Z) = nil then JeVSeznamu := False else JeVSeznamu := True;
end;



constructor TSeznamTrid.Create;
begin
Prvni := nil;
end;

destructor TSeznamTrid.Done;
begin
Reset;
end;

procedure TSeznamTrid.Reset;
var Uk1,Uk2: TPTrida;
    UkP1,UkP2: TPPredmet;
begin
  if Prvni <> nil then
  begin
    Uk1 := Prvni;
    Uk2 := Prvni.Dalsi;
    while Uk1 <> nil do
      begin
        begin
          if Uk1.Predmety <> nil then
            begin
              UkP1 := Uk1.Predmety;
              UkP2 := Uk1.Predmety.Dalsi;
              while UkP1 <> nil do
                begin
                  dispose(UkP1);
                  UkP1 := UkP2;
                  If UkP2 <> nil then UkP2 := UkP2.Dalsi;
                end;
            Uk1.Predmety := nil;
            end;
        end;

        dispose(Uk1);
        Uk1 := Uk2;
        If Uk2 <> nil then Uk2 := Uk2.Dalsi;
      end;
    Prvni := nil;
  end;
end;

procedure TSeznamTrid.Pridej(Tr:TPTrida);
begin
Tr.Dalsi := Prvni;
Prvni := Tr;
end;

procedure TSeznamTrid.Odstran(Jm:String);
var Uk1, Uk2: TPTrida;
begin
  Uk2 := Prvni;
  Uk1 := nil;
  If Uk2 <> nil then
    begin
      While (Uk2.Dalsi <> nil) AND (Uk2.Jmeno <> Jm) do
        begin
          Uk1 := Uk2;
          Uk2 := Uk2.Dalsi;
        end;
      If Uk2.Jmeno = Jm then begin
                               If Uk1 = nil then Prvni := Uk2.Dalsi else
                                                 Uk1.Dalsi := Uk2.Dalsi;
                               dispose(Uk2);
                             end;
    end;
end;

procedure TSeznamTrid.Napln;
var Tr:TTrida;
    Uk:TPTrida;
    Pr:TPredmet;
    Uk2:TPPredmet;
    i,p:Byte;
begin
  While not EOF(SouborTrid) do
    begin
      read(SouborTrid,Tr);
      new(Uk);
      Uk.Jmeno := Tr.Jmeno;
      Uk.Tridni := Tr.Tridni;
      Uk.KmenovaUcebna := Tr.KmenovaUcebna;
      Uk.PocetZaku := Tr.PocetZaku;
      Uk.Predmety := nil;
      Uk.PocetPredmetu := Tr.PocetPredmetu;
      Uk.Dalsi := nil;
      Pridej(Uk);
      p := Uk.PocetPredmetu;
      Uk.PocetPredmetu := 0;
      for i := 1 to p do
        begin
          read(SouborPredmetu,Pr);
          new(Uk2);
          Uk2.Zkratka := Pr.Zkratka;
          Uk2.Vyucuje := Pr.Vyucuje;
          Uk2.PozadovanaUcebna := Pr.PozadovanaUcebna;
          Uk2.Kolikrat := Pr.Kolikrat;
          Uk2.Dvouhodinovka := Pr.Dvouhodinovka;
          Uk2.CelaTrida := Pr.CelaTrida;
          Uk2.Zaci := Pr.Zaci;
          Uk2.Dalsi := nil;
          PridejPredmetUk(Uk,Uk2);
        end;
    end;
  CloseFile(SouborTrid);
  CloseFile(SouborPredmetu);
end;

procedure TSeznamTrid.Prazdno;
begin
  NastavNaNil;
end;

procedure TSeznamTrid.NastavNaNil;
begin
  Prvni := nil;
end;

procedure TSeznamTrid.Uloz;
var UkTr:TPTrida;
    Tr:TTrida;
    UkPr:TPPredmet;
    Pr:TPredmet;
begin
  UkTr := Prvni;
  Rewrite(SouborTrid);
  Rewrite(SouborPredmetu);
  While UkTr <> nil do
    begin
      Tr.Jmeno := UkTr.Jmeno;
      Tr.Tridni := UkTr.Tridni;
      Tr.KmenovaUcebna := UkTr.KmenovaUcebna;
      Tr.PocetZaku := UkTr.PocetZaku;
      Tr.Predmety := nil;
      Tr.PocetPredmetu := UkTr.PocetPredmetu;
      Tr.Dalsi := nil;
      write(SouborTrid,Tr);
      UkPr := UkTr.Predmety;
      While UkPr <> nil do
          begin
            Pr.Zkratka := UkPr.Zkratka;
            Pr.Vyucuje := UkPr.Vyucuje;
            Pr.PozadovanaUcebna := UkPr.PozadovanaUcebna;
            Pr.Kolikrat := UkPr.Kolikrat;
            Pr.Dvouhodinovka := UkPr.Dvouhodinovka;
            Pr.CelaTrida := UkPr.CelaTrida;
            Pr.Zaci := UkPr.Zaci;
            Pr.Dalsi := nil;
            write(SouborPredmetu,Pr);
            UkPr := UkPr.Dalsi;
          end;

      UkTr := UkTr.Dalsi;
    end;
  CloseFile(SouborTrid);
  CloseFile(SouborPredmetu);
end;

procedure TSeznamTrid.PridejPredmet(Tr:String;Pr:TPPredmet);
begin
PridejPredmetUk(VratPointerTrida(Tr),Pr);
end;

procedure TSeznamTrid.PridejPredmetUk(UkTr:TPTrida;Pr:TPPredmet);
begin
Pr.Dalsi := UkTr.Predmety;
UkTr.Predmety := Pr;
UkTr.PocetPredmetu := UkTr.PocetPredmetu + 1;
end;

procedure TSeznamTrid.SmazPredmet(Tr:String;Pr:String);
begin
SmazPredmetUk(VratPointerTrida(Tr),Pr);
end;

procedure TSeznamTrid.SmazPredmetUk(UkTr:TPTrida;Pr:String);
var Uk1, Uk2: TPPredmet;
begin
  Uk2 := UkTr.Predmety;
  Uk1 := nil;
  If Uk2 <> nil then
    begin
      While (Uk2.Dalsi <> nil) AND (Uk2.Zkratka <> Pr) do
        begin
          Uk1 := Uk2;
          Uk2 := Uk2.Dalsi;
        end;
      If Uk2.Zkratka = Pr then begin
                               If Uk1 = nil then UkTr.Predmety := Uk2.Dalsi else
                                                 Uk1.Dalsi := Uk2.Dalsi;
                               dispose(Uk2);
                               UkTr.PocetPredmetu := UkTr.PocetPredmetu - 1;
                             end;
    end;
end;

function TSeznamTrid.VratPointerTrida(Jm:String):TPTrida;
var UkTr:TPTrida;
begin
  UkTr := Prvni;
  VratPointerTrida := nil;
  If UkTr <> nil then
  begin
  while (UkTr.Dalsi <> nil) AND (UkTr.Jmeno <> Jm) do UkTr := UkTr.Dalsi;
  If UkTr.Jmeno = Jm then VratPointerTrida := UkTr;
  end;
end;

function  TSeznamTrid.VratPointerPredmet(Tr:String;Pr:String):TPPredmet;
begin
VratPointerPredmet := VratPointerPredmetUk(VratPointerTrida(Tr),Pr);
end;

function TSeznamTrid.VratPointerPredmetUk(UkTr:TPTrida;Pr:String):TPPredmet;
var UkPr:TPPredmet;
begin
  UkPr := UkTr.Predmety;
  VratPointerPredmetUk := nil;
  If UkPr <> nil then
  begin
  while (UkPr.Dalsi <> nil) AND (UkPr.Zkratka <> Pr) do UkPr := UkPr.Dalsi;
  If UkPr.Zkratka = Pr then VratPointerPredmetUk := UkPr;
  end;
end;

procedure TSeznamTrid.ZadejVyucujicihoUk(UkTr:TPTrida;Pr:String;Uc:String);
var UkPr:TPPredmet;
begin
  UkPr := VratPointerPredmetUk(UkTr,Pr);
  UkPr.Vyucuje := Uc;
end;

procedure TSeznamTrid.ZadejPozadavekNaUcebnuUk(UkTr:TPTrida;Pr:String;Uc:String);
var UkPr:TPPredmet;
begin
  UkPr := VratPointerPredmetUk(UkTr,Pr);
  If Uc = ' < nen >' then UkPr.PozadovanaUcebna := '' else UkPr.PozadovanaUcebna := Uc;
end;

procedure TSeznamTrid.ZadejKolikrat(UkTr:TPTrida;Pr:String;Kolikrat:Byte);
var UkPr:TPPredmet;
begin
  UkPr := VratPointerPredmetUk(UkTr,Pr);
  UkPr.Kolikrat := Kolikrat;
end;

procedure TSeznamTrid.ZadejCelaTridaUk(UkTr:TPTrida;Pr:String;Cela:Boolean);
var UkPr:TPPredmet;
begin
  UkPr := VratPointerPredmetUk(UkTr,Pr);
  UkPr.CelaTrida := Cela;
end;

procedure TSeznamTrid.ZadejDvouhodinovka(UkTr:TPTrida;Pr:String;Dvouhodinovka:Boolean);
var UkPr:TPPredmet;
begin
  UkPr := VratPointerPredmetUk(UkTr,Pr);
  UkPr.Dvouhodinovka := Dvouhodinovka;
end;

function TSeznamTrid.VypisUciteleUk(UkTr:TPTrida;Pr:String):String;
var UkPr:TPPredmet;
begin
  UkPr := VratPointerPredmetUk(UkTr,Pr);
  VypisUciteleUk := UkPr.Vyucuje;
end;

function TSeznamTrid.VypisPozadavekNaUcebnuUk(UkTr:TPTrida;Pr:String):String;
var UkPr:TPPredmet;
begin
  UkPr := VratPointerPredmetUk(UkTr,Pr);
  VypisPozadavekNaUcebnuUk := UkPr.PozadovanaUcebna;
end;

function TSeznamTrid.VypisCelaTrida(UkTr:TPTrida;Pr:String):Boolean;
var UkPr:TPPredmet;
begin
  UkPr := VratPointerPredmetUk(UkTr,Pr);
  VypisCelaTrida := UkPr.CelaTrida;
end;

function  TSeznamTrid.VypisKolikrat(UkTr:TPTrida;Pr:String):Byte;
var UkPr:TPPredmet;
begin
  UkPr := VratPointerPredmetUk(UkTr,Pr);
  VypisKolikrat := UkPr.Kolikrat;
end;

function TSeznamTrid.VypisDvouhodinovka(UkTr:TPTrida;Pr:String):Boolean;
var UkPr:TPPredmet;
begin
  UkPr := VratPointerPredmetUk(UkTr,Pr);
  VypisDvouhodinovka := UkPr.Dvouhodinovka;
end;

function TSeznamTrid.JeVSeznamu(Tr:String):Boolean;
begin
  If VratPointerTrida(Tr) = nil then JeVSeznamu := False else JeVSeznamu := True;
end;

function TSeznamTrid.JeTridni(var UkTr:TPTrida;Uc:String):Boolean;
var Uk:TPTrida;
begin
  JeTridni := False;
  Uk := Prvni;
  While (Uk <> nil) do
    begin
      If (Uk.Tridni = Uc) AND (Uk.Jmeno <> UkTr.Jmeno) then
         begin
           JeTridni := True;
           UkTr := Uk;
           Break;
         end;
      Uk := Uk.Dalsi;
    end;
end;

function TSeznamTrid.JeKmenovaUcebna(var UkTr:TPTrida;Uc:String):Boolean;
var Uk:TPTrida;
begin
  JeKmenovaUcebna := False;
  Uk := Prvni;
  While (Uk <> nil) do
    begin
      If (Uk.KmenovaUcebna = Uc) AND (Uk.Jmeno <> UkTr.Jmeno) then
         begin
           JeKmenovaUcebna := True;
           UkTr := Uk;
           Break;
         end;
      Uk := Uk.Dalsi;
    end;
end;

function TSeznamTrid.JePredmet(UkTr:TPTrida;Pr:String):Boolean;
var Uk:TPPredmet;
begin
  JePredmet := False;
  Uk := UkTr.Predmety;
  While (Uk <> nil) do
    begin
      If (Uk.Zkratka = Pr) then
         begin
           JePredmet := True;
           Break;
         end;
      Uk := Uk.Dalsi;
    end;
end;

constructor TSeznamUcitelu.Create;
begin
Prvni := nil;
end;

destructor TSeznamUcitelu.Done;
begin
Reset;
end;

procedure TSeznamUcitelu.Reset;
var Uk1,Uk2: TPUcitel;
begin
  if Prvni <> nil then
  begin
    Uk1 := Prvni;
    Uk2 := Prvni.Dalsi;
    while Uk1 <> nil do
      begin
        dispose(Uk1);
        Uk1 := Uk2;
        If Uk2 <> nil then Uk2 := Uk2.Dalsi;
      end;
    Prvni := nil;
  end;
end;

procedure TSeznamUcitelu.Pridej(Uc: TPUcitel);
begin
  Uc.Dalsi := Prvni;
  Prvni := Uc;

end;

procedure TSeznamUcitelu.Odstran(Jm: String);
var Uk1, Uk2: TPUcitel;
begin
  Uk2 := Prvni;
  Uk1 := nil;
  If Uk2 <> nil then
    begin
      While (Uk2.Dalsi <> nil) AND (Uk2.Jmeno <> Jm) do
        begin
          Uk1 := Uk2;
          Uk2 := Uk2.Dalsi;
        end;
      If Uk2.Jmeno = Jm then begin
                               If Uk1 = nil then Prvni := Uk2.Dalsi else
                                                 Uk1.Dalsi := Uk2.Dalsi;
                               dispose(Uk2);
                             end;
    end;
end;

procedure TSeznamUcitelu.Napln;
var Uc:TUcitel;
    Uk:TPUcitel;
begin

  While not EOF(SouborUcitelu) do
    begin
      read(SouborUcitelu,Uc);
      new(Uk);
      Uk.Jmeno := Uc.Jmeno;
      Uk.Zkratka := Uc.Zkratka;
      Uk.Hodiny := Uc.Hodiny;
      Uk.Dalsi := nil;
      Pridej(Uk);
    end;
  CloseFile(SouborUcitelu);
end;

procedure TSeznamUcitelu.Prazdno;
begin
  NastavNaNil;
end;

procedure TSeznamUcitelu.NastavNaNil;
begin
  Prvni := nil;
end;

procedure TSeznamUcitelu.Uloz;
var Uk:TPUcitel;
    Uc:TUcitel;
begin
  Uk := Prvni;
  Rewrite(SouborUcitelu);
  While not (Uk = nil) do
    begin
      Uc.Jmeno := Uk.Jmeno;
      Uc.Zkratka := Uk.Zkratka;
      Uc.Hodiny := Uk.Hodiny;
      Uc.Dalsi := nil;
      write(SouborUcitelu,Uc);
      Uk := Uk.Dalsi;
    end;
  CloseFile(SouborUcitelu);
end;

function TSeznamUcitelu.VypisZkratku(Jm:String): String;
var Uk:TPUcitel;
begin
  Uk := Prvni;
  If Uk <> nil then
  begin
  while (Uk.Dalsi <> nil) AND (Uk.Jmeno <> Jm) do Uk := Uk.Dalsi;
  If Uk.Jmeno = Jm then VypisZkratku := Uk.Zkratka else VypisZkratku := 'a';
  end
  else VypisZkratku := '';
end;

procedure TSeznamUcitelu.ZadejZkratku(Jmeno:String; Zkratka:String);
var Uk:TPUcitel;
begin
  Uk := Prvni;
  If Uk <> nil then
    begin
    while (Uk.Dalsi <> nil) AND (Uk.Jmeno <> Jmeno) do Uk := Uk.Dalsi;
    If Uk.Jmeno = Jmeno then Uk.Zkratka := Zkratka;
    end;
end;

function TSeznamUcitelu.VratPointer(Jmeno:String): TPUcitel;
var Uk:TPUcitel;
begin
  Uk := Prvni;
  VratPointer := nil;
  If Uk <> nil then
  begin
  while (Uk.Dalsi <> nil) AND (Uk.Jmeno <> Jmeno) do Uk := Uk.Dalsi;
  If Uk.Jmeno = Jmeno then VratPointer := Uk;
  end
end;

function TSeznamUcitelu.VypisHodiny(Jmeno:String): THodinySet;
var Uk:TPUcitel;
begin
  Uk := VratPointer(Jmeno);
  VypisHodiny := Uk.Hodiny;
end;

function TSeznamUcitelu.JeVSeznamu(Jmeno:String): Boolean;
begin
  If VratPointer(Jmeno) = nil then JeVSeznamu := False else JeVSeznamu := True;
end;

function TSeznamUcitelu.JeVSeznamuZkratka(var Uc:TPUcitel;Zk:String):Boolean;
var Uk:TPUcitel;
begin
  JeVSeznamuZkratka := False;
  Uk := Prvni;
  While (Uk <> nil) do
    begin
      If (Uk.Zkratka = Zk) AND (Uk.Jmeno <> Uc.Jmeno) then
         begin
           JeVSeznamuZkratka := True;
           Uc := Uk;
           Break;
         end;
      Uk := Uk.Dalsi;
    end;
end;

procedure TCentral.KonecClick(Sender: TObject);
begin
  Close;
end;

procedure TCentral.UciteleTlacClick(Sender: TObject);
begin
  Ucitele.Visible := True;
end;

procedure TCentral.FormCreate(Sender: TObject);
var Dir:String;
begin
  GetDir(0, Dir);

  SeznamUcitelu := TSeznamUcitelu.Create;
  AssignFile(SouborUcitelu, Dir + '\Data\Ucitele.roz');
  If FileExists(Dir + '\Data\Ucitele.roz') then begin Reset(SouborUcitelu);
                                          SeznamUcitelu.Napln; end
                               else SeznamUcitelu.Prazdno;
  SeznamTrid := TSeznamTrid.Create;
  AssignFile(SouborTrid, Dir + '\Data\Tridy.roz');
  AssignFile(SouborPredmetu, Dir + '\Data\Predmety.roz');
  If (FileExists(Dir + '\Data\Tridy.roz') AND FileExists(Dir + '\Data\Predmety.roz'))then
                                  begin Reset(SouborTrid);
                                        Reset(SouborPredmetu);
                                        SeznamTrid.Napln; end
                               else SeznamTrid.Prazdno;

  SeznamNazvuPredmetu := TSeznamNazvuPredmetu.Create;
  AssignFile(SouborNazvuPredmetu, Dir + '\Data\NazvyPredmetu.roz');
  If FileExists(Dir + '\Data\NazvyPredmetu.roz') then begin
                                        Reset(SouborNazvuPredmetu);
                                        SeznamNazvuPredmetu.Napln; end;

  SeznamUceben := TSeznamUceben.Create;
  AssignFile(SouborUceben, Dir + '\Data\Ucebny.roz');
  If FileExists(Dir + '\Data\Ucebny.roz') then begin
                                        Reset(SouborUceben);
                                        SeznamUceben.Napln; end;

  SeznamPriorit := TSeznamPriorit.Create;
  AssignFile(SouborPriorit, Dir + '\Data\Priority.roz');
  If FileExists(Dir + '\Data\Priority.roz') then begin
                                        Reset(SouborPriorit);
                                        SeznamPriorit.Napln; end;

  AssignFile(SouborRozvrh, Dir + '\Rozvrhy\Rozvrh.roz');
  NovyRozvrh := False;
  Randomize;
end;

procedure TCentral.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
case MessageDlg ('Uloit zmny?',
      mtCustom, [mbYes, mbNo, mbCancel], 0) of
      mrCancel: CanClose := False;
      mrNo:     begin
                SeznamUcitelu.Done;
                SeznamTrid.Done;
                SeznamNazvuPredmetu.Done;
                SeznamUceben.Done;
                SeznamPriorit.Done;
                end;
      mrYes:    begin
                SeznamUcitelu.Uloz;
                SeznamUcitelu.Done;
                SeznamTrid.Uloz;
                SeznamTrid.Done;
                SeznamNazvuPredmetu.Uloz;
                SeznamNazvuPredmetu.Done;
                SeznamUceben.Uloz;
                SeznamUceben.Done;
                SeznamPriorit.Uloz;
                SeznamPriorit.Done;
                end;
      end;
end;

procedure TCentral.TridyaZaciClick(Sender: TObject);
begin
Tridy.Visible := True;
end;

procedure TCentral.PriorityButtonClick(Sender: TObject);
begin
  Priority.Visible := True;
end;

procedure TCentral.PredmetyClick(Sender: TObject);
begin
Predmety_unit.Predmety.Visible := True;
end;

procedure TCentral.UcebnyClick(Sender: TObject);
begin
Ucebny_unit.Ucebny.Visible := True;
end;

procedure TCentral.VytvorRozvrhClick(Sender: TObject);
begin
TvorbaRozvrhu_unit.Akce;
end;

procedure TCentral.ZobrazRozvrhClick(Sender: TObject);
begin
  OtevriRozvrh.FileName := '';
  OtevriRozvrh.Execute;
  RozvrhKopie := TRozvrh.Create;
  try
  AssignFile(SouborRozvrh,OtevriRozvrh.FileName);
  RozvrhKopie.Napln;
  NovyRozvrh := False;
  VysledkyVyberTridy.Visible := True;
  except
  RozvrhKopie.Done;
  end;
end;

procedure TCentral.ZobrazitUlozenyClick(Sender: TObject);
begin
ZobrazRozvrhClick(Sender);
end;

procedure TCentral.UlozitClick(Sender: TObject);
begin
  SeznamUcitelu.Uloz;
  SeznamTrid.Uloz;
  SeznamNazvuPredmetu.Uloz;
  SeznamUceben.Uloz;
  SeznamPriorit.Uloz;
end;

procedure TCentral.NacistClick(Sender: TObject);
begin
  If MessageDlg('Zmny od poslednho uloen budou ztraceny. Chcete pokraovat?',
                mtCustom, [mbOK, mbCancel], 0) = mrOK then
        begin
          SeznamUcitelu.Done;
          SeznamTrid.Done;
          SeznamNazvuPredmetu.Done;
          SeznamUceben.Done;
          SeznamPriorit.Done;
          FormCreate(Sender);
        end;
end;

procedure TCentral.OAplikaciClick(Sender: TObject);
begin
OAplikaci_unit.OAplikaci.Visible := True;
end;

procedure TCentral.NapovedaProRozvrhyClick(Sender: TObject);
begin
Napoveda_unit.Napoveda.Visible := True;
end;

end.
