unit Predmety_unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Central_unit;

type
  TPredmety = class(TForm)
    PredmetyListBox: TListBox;
    Label1: TLabel;
    Pridej: TButton;
    Smaz: TButton;
    OK: TButton;
    Storno: TButton;
    NazevLabel: TLabel;
    procedure FormShow(Sender: TObject);
    procedure PridejClick(Sender: TObject);
    procedure PredmetyListBoxClick(Sender: TObject);
    procedure StornoClick(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure SmazClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Predmety: TPredmety;
  SeznamNazvuPredmetuZaloha: TSeznamNazvuPredmetu;
  StisknutoOK: Boolean;
implementation

uses PridejPredmetDoSeznamu_unit;
{$R *.DFM}

procedure TPredmety.FormShow(Sender: TObject);
var Uk,Novy:TPNazvyPredmetu;
begin
NazevLabel.Caption := '';
StisknutoOK := False;
SeznamNazvuPredmetuZaloha := TSeznamNazvuPredmetu.Create;
Uk := SeznamNazvuPredmetu.Prvni;
While Uk <> nil do
  begin
    new(Novy);
    Novy.Nazev := Uk.Nazev;
    Novy.Zkratka := Uk.Zkratka;
    Novy.Dalsi := nil;
    SeznamNazvuPredmetuZaloha.Pridej(Novy);
    Uk := Uk.Dalsi;
  end;

PredmetyListBox.Clear;  
Uk := SeznamNazvuPredmetu.Prvni;
While Uk <> nil do
  begin
    PredmetyListBox.Items.Add(Uk.Zkratka);
    Uk := Uk.Dalsi;
  end;
ActiveControl := PredmetyListBox;
end;

procedure TPredmety.PridejClick(Sender: TObject);
begin
PridejPredmetDoSeznamu_unit.PridejPredmetDoSeznamu.Visible := True;
end;

procedure TPredmety.PredmetyListBoxClick(Sender: TObject);
begin
NazevLabel.Caption := SeznamNazvuPredmetu.VypisNazev(PredmetyListbox.Items.Strings[PredmetyListBox.ItemIndex]);
end;

procedure TPredmety.StornoClick(Sender: TObject);
begin
Close;
end;

procedure TPredmety.OKClick(Sender: TObject);
begin
StisknutoOK := True;
Close;
end;

procedure TPredmety.SmazClick(Sender: TObject);
begin
If PredmetyListBox.Selected[PredmetyListBox.ItemIndex] then
  begin
    SeznamNazvuPredmetu.Odstran(PredmetyListbox.Items.Strings[PredmetyListBox.ItemIndex]);
    PredmetyListbox.Items.Delete(PredmetyListBox.ItemIndex);
    NazevLabel.Caption := '';
  end;  
end;

procedure TPredmety.FormClose(Sender: TObject; var Action: TCloseAction);
begin
If StisknutoOK then SeznamNazvuPredmetuZaloha.Done
               else begin
                    SeznamNazvuPredmetu.Reset;
                    SeznamNazvuPredmetu.Prvni := SeznamNazvuPredmetuZaloha.Prvni;
                    SeznamNazvuPredmetuZaloha.Prvni := nil;
                    SeznamNazvuPredmetuZaloha.Done;
                    end;
end;

end.
